﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WinForms;

namespace _8619
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.Meter;
            
            LayerOverlay layerOverlay = new LayerOverlay();

            RectangleShape rect = new RectangleShape(0, 22100, 25600, 0);
            
            InMemoryFeatureLayer vectorLayer = new InMemoryFeatureLayer();
            vectorLayer.InternalFeatures.Add(new Feature(rect));
            vectorLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(new GeoSolidBrush(GeoColor.SimpleColors.Red)));
            vectorLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            vectorLayer.Open();

            NativeImageRasterLayer rasterLayer = new NativeImageRasterLayer(@"..\..\AppData\testImage.jpeg", rect);
            rasterLayer.Open();

            RotationProjection rotate = new RotationProjection();
            rotate.Open();
            rasterLayer.ImageSource.Projection = rotate;
            vectorLayer.FeatureSource.Projection = rotate;

            layerOverlay.Layers.Add(vectorLayer);
            layerOverlay.Layers.Add(rasterLayer);
            winformsMap1.Overlays.Add("overlay", layerOverlay);

            winformsMap1.CurrentExtent = vectorLayer.GetBoundingBox();
            winformsMap1.Refresh();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            RotationProjection rotate = ((winformsMap1.Overlays["overlay"] as LayerOverlay).Layers[1] as NativeImageRasterLayer).ImageSource.Projection as RotationProjection;

            rotate.Angle += 10;

            winformsMap1.CurrentExtent = rotate.GetUpdatedExtent(winformsMap1.CurrentExtent);
            winformsMap1.Refresh();
        }
    }
}
